//Je protège mon .h contre les inclusions multiples
#ifndef FINDDIALOG_H
#define FINDDIALOG_H

//J'inclus QDialog, indispensable puisque c'est ma classe mère
#include <QDialog>
//Je déclare les classes Qt que je vais utiliser; je peux faire ça à la place d'un "include" parce qu'ici je ne déclare que des pointeurs (pas d'instanciation)
// et donc pas besoin de définition complète de la classe. Avantage de cette méthode : rapidité de compilation
class QCheckBox;
class QLabel;
class QLineEdit;
class QPushButton;

class FindDialog : public QDialog
{
    //Je vais créer moi-même des signaux et slots, donc indispensable d'écrire la commande
    Q_OBJECT
public:
    //Je spécifie dans mon constructeur par défaut que ma boite de dialogue n'a pas de Widget "parent"
    FindDialog(QWidget *parent = 0);
signals:
    //Je crée deux signaux qui n'existent pas de façon native dans QDialog (sinon je les aurais hérités)
    void findNext(const QString &str, Qt::CaseSensitivity cs);
    void findPrevious(const QString &str, Qt::CaseSensitivity cs);

private slots :
    //Je crée deux slots qui n'existent pas de façon native dans QDialog (sinon je les aurais hérités)
    void findClicked();
    void enableFindButton(const QString & text);

private :
    QLabel *label;
    QLineEdit *lineEdit;
    QCheckBox *caseCheckBox;
    QCheckBox *backwardCheckBox;
    QPushButton *findButton;
    QPushButton *closeButton;
};

#endif // FINDDIALOG_H
